// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: Tile.proto
#ifdef _MSC_VER
#pragma warning(disable:4125)
#endif
#include "Tile.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/port.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/io/zero_copy_stream_impl_lite.h>
// This is a temporary google only hack
#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
#include "third_party/protobuf/version.h"
#endif
// @@protoc_insertion_point(includes)

namespace dfproto {
class TileDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<Tile>
      _instance;
} _Tile_default_instance_;
}  // namespace dfproto
namespace protobuf_Tile_2eproto {
static void InitDefaultsTile() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

  {
    void* ptr = &::dfproto::_Tile_default_instance_;
    new (ptr) ::dfproto::Tile();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::dfproto::Tile::InitAsDefaultInstance();
}

::google::protobuf::internal::SCCInfo<0> scc_info_Tile =
    {{ATOMIC_VAR_INIT(::google::protobuf::internal::SCCInfoBase::kUninitialized), 0, InitDefaultsTile}, {}};

void InitDefaults() {
  ::google::protobuf::internal::InitSCC(&scc_info_Tile.base);
}

}  // namespace protobuf_Tile_2eproto
namespace dfproto {
bool Tile_TileType_IsValid(int value) {
  switch (value) {
    case 0:
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
    case 6:
    case 7:
    case 8:
    case 9:
    case 10:
    case 11:
    case 12:
    case 13:
    case 14:
    case 15:
    case 16:
      return true;
    default:
      return false;
  }
}

#if !defined(_MSC_VER) || _MSC_VER >= 1900
const Tile_TileType Tile::EMPTY;
const Tile_TileType Tile::FLOOR;
const Tile_TileType Tile::BOULDER;
const Tile_TileType Tile::PEBBLES;
const Tile_TileType Tile::WALL;
const Tile_TileType Tile::FORTIFICATION;
const Tile_TileType Tile::STAIR_UP;
const Tile_TileType Tile::STAIR_DOWN;
const Tile_TileType Tile::STAIR_UPDOWN;
const Tile_TileType Tile::RAMP;
const Tile_TileType Tile::RAMP_TOP;
const Tile_TileType Tile::BROOK_BED;
const Tile_TileType Tile::BROOK_TOP;
const Tile_TileType Tile::TREE;
const Tile_TileType Tile::SAPLING;
const Tile_TileType Tile::SHRUB;
const Tile_TileType Tile::ENDLESS_PIT;
const Tile_TileType Tile::TileType_MIN;
const Tile_TileType Tile::TileType_MAX;
const int Tile::TileType_ARRAYSIZE;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900
bool Tile_LiquidType_IsValid(int value) {
  switch (value) {
    case 0:
    case 1:
      return true;
    default:
      return false;
  }
}

#if !defined(_MSC_VER) || _MSC_VER >= 1900
const Tile_LiquidType Tile::WATER;
const Tile_LiquidType Tile::MAGMA;
const Tile_LiquidType Tile::LiquidType_MIN;
const Tile_LiquidType Tile::LiquidType_MAX;
const int Tile::LiquidType_ARRAYSIZE;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900
bool Tile_TileMaterialType_IsValid(int value) {
  switch (value) {
    case 0:
    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
    case 6:
    case 7:
    case 8:
    case 9:
    case 10:
    case 11:
    case 12:
    case 13:
    case 14:
    case 15:
    case 16:
    case 17:
    case 18:
    case 19:
    case 20:
      return true;
    default:
      return false;
  }
}

#if !defined(_MSC_VER) || _MSC_VER >= 1900
const Tile_TileMaterialType Tile::AIR;
const Tile_TileMaterialType Tile::SOIL;
const Tile_TileMaterialType Tile::STONE;
const Tile_TileMaterialType Tile::FEATURE;
const Tile_TileMaterialType Tile::LAVA_STONE;
const Tile_TileMaterialType Tile::MINERAL;
const Tile_TileMaterialType Tile::FROZEN_LIQUID;
const Tile_TileMaterialType Tile::CONSTRUCTION;
const Tile_TileMaterialType Tile::GRASS_LIGHT;
const Tile_TileMaterialType Tile::GRASS_DARK;
const Tile_TileMaterialType Tile::GRASS_DRY;
const Tile_TileMaterialType Tile::GRASS_DEAD;
const Tile_TileMaterialType Tile::HFS;
const Tile_TileMaterialType Tile::CAMPFIRE;
const Tile_TileMaterialType Tile::FIRE;
const Tile_TileMaterialType Tile::ASHES;
const Tile_TileMaterialType Tile::MAGMA_TYPE;
const Tile_TileMaterialType Tile::DRIFTWOOD;
const Tile_TileMaterialType Tile::POOL;
const Tile_TileMaterialType Tile::BROOK;
const Tile_TileMaterialType Tile::RIVER;
const Tile_TileMaterialType Tile::TileMaterialType_MIN;
const Tile_TileMaterialType Tile::TileMaterialType_MAX;
const int Tile::TileMaterialType_ARRAYSIZE;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

// ===================================================================

void Tile::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int Tile::kXFieldNumber;
const int Tile::kYFieldNumber;
const int Tile::kTypeFieldNumber;
const int Tile::kTileMaterialFieldNumber;
const int Tile::kMaterialIndexFieldNumber;
const int Tile::kMaterialTypeFieldNumber;
const int Tile::kLiquidTypeFieldNumber;
const int Tile::kFlowSizeFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

Tile::Tile()
  : ::google::protobuf::MessageLite(), _internal_metadata_(NULL) {
  ::google::protobuf::internal::InitSCC(
      &protobuf_Tile_2eproto::scc_info_Tile.base);
  SharedCtor();
  // @@protoc_insertion_point(constructor:dfproto.Tile)
}
Tile::Tile(const Tile& from)
  : ::google::protobuf::MessageLite(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::memcpy(&x_, &from.x_,
    static_cast<size_t>(reinterpret_cast<char*>(&flow_size_) -
    reinterpret_cast<char*>(&x_)) + sizeof(flow_size_));
  // @@protoc_insertion_point(copy_constructor:dfproto.Tile)
}

void Tile::SharedCtor() {
  ::memset(&x_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&flow_size_) -
      reinterpret_cast<char*>(&x_)) + sizeof(flow_size_));
}

Tile::~Tile() {
  // @@protoc_insertion_point(destructor:dfproto.Tile)
  SharedDtor();
}

void Tile::SharedDtor() {
}

void Tile::SetCachedSize(int size) const {
  _cached_size_.Set(size);
}
const Tile& Tile::default_instance() {
  ::google::protobuf::internal::InitSCC(&protobuf_Tile_2eproto::scc_info_Tile.base);
  return *internal_default_instance();
}


void Tile::Clear() {
// @@protoc_insertion_point(message_clear_start:dfproto.Tile)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  if (cached_has_bits & 255u) {
    ::memset(&x_, 0, static_cast<size_t>(
        reinterpret_cast<char*>(&flow_size_) -
        reinterpret_cast<char*>(&x_)) + sizeof(flow_size_));
  }
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool Tile::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  ::google::protobuf::internal::LiteUnknownFieldSetter unknown_fields_setter(
      &_internal_metadata_);
  ::google::protobuf::io::StringOutputStream unknown_fields_output(
      unknown_fields_setter.buffer());
  ::google::protobuf::io::CodedOutputStream unknown_fields_stream(
      &unknown_fields_output, false);
  // @@protoc_insertion_point(parse_start:dfproto.Tile)
  for (;;) {
    ::std::pair<::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // required uint32 x = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {
          set_has_x();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::uint32, ::google::protobuf::internal::WireFormatLite::TYPE_UINT32>(
                 input, &x_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // required uint32 y = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(16u /* 16 & 0xFF */)) {
          set_has_y();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::uint32, ::google::protobuf::internal::WireFormatLite::TYPE_UINT32>(
                 input, &y_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // required .dfproto.Tile.TileType type = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(24u /* 24 & 0xFF */)) {
          int value;
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
          if (::dfproto::Tile_TileType_IsValid(value)) {
            set_type(static_cast< ::dfproto::Tile_TileType >(value));
          } else {
            unknown_fields_stream.WriteVarint32(24u);
            unknown_fields_stream.WriteVarint32(
                static_cast< ::google::protobuf::uint32>(value));
          }
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional .dfproto.Tile.TileMaterialType tile_material = 4;
      case 4: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(32u /* 32 & 0xFF */)) {
          int value;
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
          if (::dfproto::Tile_TileMaterialType_IsValid(value)) {
            set_tile_material(static_cast< ::dfproto::Tile_TileMaterialType >(value));
          } else {
            unknown_fields_stream.WriteVarint32(32u);
            unknown_fields_stream.WriteVarint32(
                static_cast< ::google::protobuf::uint32>(value));
          }
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional uint32 material_index = 5;
      case 5: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(40u /* 40 & 0xFF */)) {
          set_has_material_index();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::uint32, ::google::protobuf::internal::WireFormatLite::TYPE_UINT32>(
                 input, &material_index_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional uint32 material_type = 6;
      case 6: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(48u /* 48 & 0xFF */)) {
          set_has_material_type();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::uint32, ::google::protobuf::internal::WireFormatLite::TYPE_UINT32>(
                 input, &material_type_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional .dfproto.Tile.LiquidType liquid_type = 7;
      case 7: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(56u /* 56 & 0xFF */)) {
          int value;
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
          if (::dfproto::Tile_LiquidType_IsValid(value)) {
            set_liquid_type(static_cast< ::dfproto::Tile_LiquidType >(value));
          } else {
            unknown_fields_stream.WriteVarint32(56u);
            unknown_fields_stream.WriteVarint32(
                static_cast< ::google::protobuf::uint32>(value));
          }
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional uint32 flow_size = 8;
      case 8: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(64u /* 64 & 0xFF */)) {
          set_has_flow_size();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::uint32, ::google::protobuf::internal::WireFormatLite::TYPE_UINT32>(
                 input, &flow_size_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormatLite::SkipField(
            input, tag, &unknown_fields_stream));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:dfproto.Tile)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:dfproto.Tile)
  return false;
#undef DO_
}

void Tile::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:dfproto.Tile)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // required uint32 x = 1;
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteUInt32(1, this->x(), output);
  }

  // required uint32 y = 2;
  if (cached_has_bits & 0x00000002u) {
    ::google::protobuf::internal::WireFormatLite::WriteUInt32(2, this->y(), output);
  }

  // required .dfproto.Tile.TileType type = 3;
  if (cached_has_bits & 0x00000004u) {
    ::google::protobuf::internal::WireFormatLite::WriteEnum(
      3, this->type(), output);
  }

  // optional .dfproto.Tile.TileMaterialType tile_material = 4;
  if (cached_has_bits & 0x00000008u) {
    ::google::protobuf::internal::WireFormatLite::WriteEnum(
      4, this->tile_material(), output);
  }

  // optional uint32 material_index = 5;
  if (cached_has_bits & 0x00000010u) {
    ::google::protobuf::internal::WireFormatLite::WriteUInt32(5, this->material_index(), output);
  }

  // optional uint32 material_type = 6;
  if (cached_has_bits & 0x00000020u) {
    ::google::protobuf::internal::WireFormatLite::WriteUInt32(6, this->material_type(), output);
  }

  // optional .dfproto.Tile.LiquidType liquid_type = 7;
  if (cached_has_bits & 0x00000040u) {
    ::google::protobuf::internal::WireFormatLite::WriteEnum(
      7, this->liquid_type(), output);
  }

  // optional uint32 flow_size = 8;
  if (cached_has_bits & 0x00000080u) {
    ::google::protobuf::internal::WireFormatLite::WriteUInt32(8, this->flow_size(), output);
  }

  output->WriteRaw(_internal_metadata_.unknown_fields().data(),
                   static_cast<int>(_internal_metadata_.unknown_fields().size()));
  // @@protoc_insertion_point(serialize_end:dfproto.Tile)
}

size_t Tile::RequiredFieldsByteSizeFallback() const {
// @@protoc_insertion_point(required_fields_byte_size_fallback_start:dfproto.Tile)
  size_t total_size = 0;

  if (has_x()) {
    // required uint32 x = 1;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->x());
  }

  if (has_y()) {
    // required uint32 y = 2;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->y());
  }

  if (has_type()) {
    // required .dfproto.Tile.TileType type = 3;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::EnumSize(this->type());
  }

  return total_size;
}
size_t Tile::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:dfproto.Tile)
  size_t total_size = 0;

  total_size += _internal_metadata_.unknown_fields().size();

  if (((_has_bits_[0] & 0x00000007) ^ 0x00000007) == 0) {  // All required fields are present.
    // required uint32 x = 1;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->x());

    // required uint32 y = 2;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::UInt32Size(
        this->y());

    // required .dfproto.Tile.TileType type = 3;
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::EnumSize(this->type());

  } else {
    total_size += RequiredFieldsByteSizeFallback();
  }
  if (_has_bits_[0 / 32] & 248u) {
    // optional .dfproto.Tile.TileMaterialType tile_material = 4;
    if (has_tile_material()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::EnumSize(this->tile_material());
    }

    // optional uint32 material_index = 5;
    if (has_material_index()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::UInt32Size(
          this->material_index());
    }

    // optional uint32 material_type = 6;
    if (has_material_type()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::UInt32Size(
          this->material_type());
    }

    // optional .dfproto.Tile.LiquidType liquid_type = 7;
    if (has_liquid_type()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::EnumSize(this->liquid_type());
    }

    // optional uint32 flow_size = 8;
    if (has_flow_size()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::UInt32Size(
          this->flow_size());
    }

  }
  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  SetCachedSize(cached_size);
  return total_size;
}

void Tile::CheckTypeAndMergeFrom(
    const ::google::protobuf::MessageLite& from) {
  MergeFrom(*::google::protobuf::down_cast<const Tile*>(&from));
}

void Tile::MergeFrom(const Tile& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:dfproto.Tile)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = from._has_bits_[0];
  if (cached_has_bits & 255u) {
    if (cached_has_bits & 0x00000001u) {
      x_ = from.x_;
    }
    if (cached_has_bits & 0x00000002u) {
      y_ = from.y_;
    }
    if (cached_has_bits & 0x00000004u) {
      type_ = from.type_;
    }
    if (cached_has_bits & 0x00000008u) {
      tile_material_ = from.tile_material_;
    }
    if (cached_has_bits & 0x00000010u) {
      material_index_ = from.material_index_;
    }
    if (cached_has_bits & 0x00000020u) {
      material_type_ = from.material_type_;
    }
    if (cached_has_bits & 0x00000040u) {
      liquid_type_ = from.liquid_type_;
    }
    if (cached_has_bits & 0x00000080u) {
      flow_size_ = from.flow_size_;
    }
    _has_bits_[0] |= cached_has_bits;
  }
}

void Tile::CopyFrom(const Tile& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:dfproto.Tile)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool Tile::IsInitialized() const {
  if ((_has_bits_[0] & 0x00000007) != 0x00000007) return false;
  return true;
}

void Tile::Swap(Tile* other) {
  if (other == this) return;
  InternalSwap(other);
}
void Tile::InternalSwap(Tile* other) {
  using std::swap;
  swap(x_, other->x_);
  swap(y_, other->y_);
  swap(type_, other->type_);
  swap(tile_material_, other->tile_material_);
  swap(material_index_, other->material_index_);
  swap(material_type_, other->material_type_);
  swap(liquid_type_, other->liquid_type_);
  swap(flow_size_, other->flow_size_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
}

::std::string Tile::GetTypeName() const {
  return "dfproto.Tile";
}


// @@protoc_insertion_point(namespace_scope)
}  // namespace dfproto
namespace google {
namespace protobuf {
template<> GOOGLE_PROTOBUF_ATTRIBUTE_NOINLINE ::dfproto::Tile* Arena::CreateMaybeMessage< ::dfproto::Tile >(Arena* arena) {
  return Arena::CreateInternal< ::dfproto::Tile >(arena);
}
}  // namespace protobuf
}  // namespace google

// @@protoc_insertion_point(global_scope)
